module.exports =(options)->
	cradle = require 'cradle'
	
	client = new cradle.Connection options.host, options.port, options.cradle
		
	db = client.database options.db
	
	Object.defineProperty @::, 'id', enumerable: true, get:(->@meta._id), set:((val)->@meta._id = val)

	model = @
	
	return interface=	
		get:(id, cb)->
			unless id
				return cb({error: 'no id supplied'}) if cb
			console.log 'getting',options.db, id	
			db.get id, (err, doc)->
				if err
					return cb(err) if cb
				else
					m = model.new(doc)
					return cb null, m if cb
	
		view:(view, opts, cb)->
			model.db.view view, opts, (err, doc)->
				if err
					return cb(err) if cb
				else
					rows =  _(doc).map (row)->model.new(row.value)
					return cb null, rows if cb
		
		save:(cb)->
			if @meta._id
				@attrs._id = @meta._id
			if @meta._rev
				@attrs._rev = @meta._rev
				
			db.save @attrs, (err, resp)=>
				unless err
					@meta._id = resp.id
					@meta._rev = resp.rev
				# console.log 'saved',err,resp	
				cb(err, @attrs) if cb
			delete @attrs._id
			delete @attrs._rev
		
		parse:->
			@meta = _id: @attrs.id or @attrs._id or null, _rev: @attrs._rev or null
			delete @attrs.id
			delete @attrs._id
			delete @attrs._rev
		