CC = require('coffeeclass').CC
# D# ana
# props: [ id1, id2 ]
# 	obj1: Obj.get id: id1
# 	obj2: Obj.get id: id2
# 	obj3: Obj.get id: obj1->sibling
# 	obj4: Obj.get id: obj2->sibling
# 	work: sync obj: obj1, with: obj4
# 	work2: sync obj: obj3, with: obj2
# 

require 'josp'

wait = 100
Obj =
	reads: 0
	users:
		obj1:
			name: 'Object 1'
			sibling: 'obj3'
		obj2:
			name: 'Object 2'
			sibling: 'obj4'
		obj3:
			name: 'Object 3'
			sibling: 'obj1'
		obj4:
			name: 'Object 4'
			sibling: 'obj2'
	get:(id, cb)->
		# console.log 'called with',id
		@reads++
		user =
			__proto__: @users[id]
			tag: Math.random()
			sibling: (uid for uid of @users)[Math.floor(Math.random()*4)]
			name: @users[id].name
				
		# console.log 'getting', id,'sibling is',user.sibling
		setTimeout cb, wait, null, user

# Obj.dget = new dexp { 'id' }, (cb)->
# 	Obj.get @id, cb
		
		

work = 100
sync=(a, b)->
	i = work
	while --i
		a.name + b.name
	a.name + b.name
# 
# 
# dsync = new dexp { 'obj', 'with' }, (cb)->
# 	process.nextTick ()=> cb null, sync(@obj, @with)
# 
if Object.prototype.__exec?
	Get = CC.wrap { 'id' }, (cb)->
			# console.log 'calling with',@id
			Obj.get @id, cb
			return undefined
		
	dsync = CC.wrap {'obj','with'}, -> sync @obj, @with
	# Josp# 
	# props = new dexp { 'id1', 'id2' }
	# props.obj1 = Obj.dget.exec id: props._scope.id1
	# props.obj2 = Obj.dget.exec id: props._scope.id2
	# props.obj3 = Obj.dget.exec id: props.obj1.arrow 'sibling'
	# props.obj4 = Obj.dget.exec id: props.obj2.arrow 'sibling'
	# props.work = dsync.exec obj: props.obj1, with: props.obj4
	# props.work2 = dsync.exec obj: props.obj3, with: props.obj2
	# 
	
# CC
props = CC class props
		CC.args @, {'id1', 'id2'}	
	
		obj1: Get {id: @::id1}
		obj2: Get {id: @::id2}
		obj3: Get {id: @::obj1.__arrow 'sibling'}
		obj4: Get {id: @::obj2.__arrow 'sibling'}
		work: dsync {obj: @::obj1, with: @::obj4}
		work2: dsync {obj: @::obj3, with: @::obj2}


run_josp = (cb, id1='obj1', id2='obj2') ->
	Object.__ctx = {id1, id2}
	props.__do cb


# Raw Node

run_node = ( cb, id1='obj1', id2='obj2' ) ->
	out = {
		obj1: null
		obj2: null
		obj3: null
		obj4: null
		work: null
		work2: null
	}
	
	get2 =->
		if out.obj3 and out.obj4
			out.work = sync out.obj1, out.obj4
			out.work2 = sync out.obj3, out.obj2
			cb null, out
	
	get1 =->
		if out.obj1 and out.obj2
			Obj.get out.obj1.sibling, (err, doc)->get2 out.obj3 = doc
			Obj.get out.obj2.sibling, (err, doc)->get2 out.obj4 = doc	
	
	Obj.get id1, (err, doc)->get1 out.obj1 = doc	
	Obj.get id2, (err, doc)->get1 out.obj2 = doc
	
goal = 1000000
bench =(fns, threads)->
	interval = threads * 10
	stats = {}
	for name of fns
		stats[name] = tally: 0, total: 0
	start = new Date().valueOf()
	run =(name, fn)->
		t = new Date().valueOf()
		fn (err, doc)->
			# console.log 'return',name,err,doc,stats
			now = new Date().valueOf()
			lag = now - t
			# console.log 'delay was', lag
			elapsed = now - start
			stats[name].tally++
			stats[name].total+=lag
			unless stats[name].tally % interval
				process.send stats[name]
				stats[name] = tally: 0, total: 0
				# console.log name,'queries:',stats[name].tally,'avg:',stats[name].total/stats[name].tally,'qps:',stats[name].tally/elapsed * 1000, 'reads: ',Obj.reads
			# console.log 'running again'		
			run(name, fn) unless stats[name].tally > goal
	while threads--
		for k of fns
			run(k, fns[k])
# bench {'node': run_node, 'josp': run_josp}, 1000
bench {'josp': run_josp}, 1500
# bench {'node': run_node}, 1500
# fn =->
#run_josp (er, res)->console.log 'result of josp is', res
#run_node (er, res)->console.log 'result of node is', res
# 	run_josp (err, args)-> 
# 		console.log args, 'ran once, running again' 
# 		fn()
# fn()
# total = 0
# tally = 0
# time =->
# 	console.log 'start:',start = new Date().valueOf()
# 	run_josp (err, res)->
# 		console.log 'finish',end = new Date().valueOf()
# 		# console.log 'result',res
# 		console.log 'delay was',end-start
# 		total += end-start
# 		tally++
# 		console.log 'average delay',total/tally
# 		time()
# 
# time()
# time()
# time()
# time()
# # 
# dd = props.__exec {id1: 'obj1', id2: 'obj2'}
# 
# dd.__do console.log
# dd.__do console.log
# dd.__do console.log
