require 'josp'
CC = module.exports = class ConcurrentC
	
	@args:(k, names)->
		throw new Error 'CoffeeClass requires the Josp interpreter to be loaded.' unless k::__setargs?
		k::__setargs names
		#k::__proto__ = k::__args = {}
	
	@wrap:(args, fn)->
		(input)->
			for prop of args
				unless prop of input
					throw new Error "#{@__key} call requires property `#{prop}`."
			
			c =(cb)-> fn.call(@, cb)
			
			Object.defineProperty c, '__input', value: input
			c
	
	@or:(calls...)->
		# console.log 'or', calls
		ob = __do:(done)->
			errors = [] 
			it = 0
			#spooooky! first we have to cache the context
			#lesson here is don't change the context
			context = Object.__ctx
			cb =(res)->
				unless typeof res.__err is 'undefined'
					#We have a problem.
					errors.push res
					
					if ++it is calls.length
						res = new Error
						res.__err = errors
						return done res

					else
						#spooooky
						Object.__ctx = context
						calls[it].__do cb
				else
					done res
					
			call = calls[it]
			
			while call.__value?
				call = call.__value
				
			call.__do cb
					
	@and:(calls...)->
		# console.log 'or', calls
		ob = __do:(done)->
			errors = [] 
			it = 0
			#spooooky! first we have to cache the context
			#lesson here is don't change the context
			context = Object.__ctx
			cb =(res)->
				unless typeof res.__err is 'undefined'
					#We have a problem.
					done res
				else
					if ++it is calls.length
						return done res
					else
						#spooooky
						Object.__ctx = context
						calls[it].__do cb
					
			call = calls[it]
			
			while call.__value?
				call = call.__value
				
			call.__do cb
	@pass:(input, fn)->
		Object.defineProperty fn, '__input', value:input
		fn
		
	constructor:(k)->
		k::__key = k::constructor.name  
		delete k::constructor
		for prop of k::
			# console.log prop, k::[prop]
			k::[prop].__key = prop
		return k::

return
require 'josp'
wait = 10
Obj =
	reads: 0
	users:
		obj1:
			name: 'Object 1'
			sibling: 'obj3'
		obj2:
			name: 'Object 2'
			sibling: 'obj4'
		obj3:
			name: 'Object 3'
			sibling: 'obj1'
		obj4:
			name: 'Object 4'
			sibling: 'obj2'
	get:(id, cb)->
		# console.log 'called with',id
		@reads++
		unless id of @users
			err = {error: 'not found'}
			user = null
		else
			err = null
			user =
				__proto__: @users[id]
				tag: Math.random()
				sibling: (uid for uid of @users)[Math.floor(Math.random()*4)]
				name: @users[id].name
				
		console.log 'getting', id,'sibling is',user?.sibling
		setTimeout cb, wait, err, user

#return
Get = CC.wrap { 'id' }, (cb)->
		Obj.get @id, cb
		return undefined
		
sync = CC.wrap {'obj','with'}, ->return "synced #{@obj.name} with #{@with.sibling}"
details = CC (class details
	CC.args @, {'id'}
	
	bingy: Get { id: @::id }
	thingy: @::bingy.__arrow 'sibling'
	
)
cat =(args...)->
	fn=->@join('')
	fn.__input = args
	fn
		
API = 

	get: CC class get	
		CC.args @, {'id1', 'id2'}	
		a: CC.or Get({id: @::id1}), Get({id: @::id2}), Get({id: cat(@::id1, @::id2)})
		obj2: Get {id: @::id2}
		e: @::a.__not
		# 		b: Get {id: @::id2}#obj1.__arrow 'sibling'}
		# 		tags: [@::a.__arrow('tag'), @::b.__arrow ('tag')]
		# 		hashtags:
		# 				a: @::a.__arrow 'tag'
		# 				b: @::b.__arrow 'tag'
	
# co# nsole.log 'props', props.prototype
# o = Get {id: 'obj1'}
# d = details.__exec {id: 'obj1'}
# d.__do console.log
# # d.__clear()
# # 
# dd = details.__exec {id: 'obj3'}
# # console.log 'd', d.__input
# # console.log 'dd', dd.__input
# dd.__do console.log
# # dd.__dot().__do console.log
# # dd.__dot()
# # 
# setTimeout (->d.__dot().__do console.log), 1000
# 
## 
# console.log g = Get({ id: 'obj1' })
# console.log g.__do.toString()
# console.log g.__input
# g.__do console.log

# CallbackInterpreter = require 'callback'
# 
# API = new CallbackInterpreter API
# console.log 'calling get'
# d =(id)-> API.get {id1: 'obj1', id2: id}, (res)->
# 	console.log 'callback',res
# d('obj2')
# d('bob')
# console.log API.get

Object.__ctx = {id1: 'ob', id2: 'j3'}
API.get.__do console.log# 
Object.__ctx = {id1: 'obj2', id2: 'obj4'}
API.get.__do console.log
Object.__ctx = {id1: 'obj1', id2: 'obj1'}
API.get.__do console.log

	