###
# The JavaScript Object Processor ('Josp')
###
Object.defineProperty Object.prototype, '__key', 
	configurable:true
	get:->undefined
	set:(val)->
		Object.defineProperty @, '__key', value:val
		

Object.defineProperty Object.prototype, '__ctx', value:{}, writable:true

Object.defineProperty Object.prototype, '__arg', get:->
	key = @
	#key of @
	__do:(cb)->
		# console.log 'arg accessed',key
		val = Object.__ctx[key]
		if typeof val is 'undefined'
			val = new Error
			val.__err = "no input #{key} provided"
		process.nextTick -> cb val

Object.defineProperty Object.prototype, '__setargs', value:(names)->
	Object.defineProperty @, '__args', value: {}
	@__proto__ = @__args
	
	for name of names
		@__args[name] = name.__arg
		
		
Object.defineProperty Object.prototype, '__arrow', value:(prop)->
		return @__arrows[prop] if @__arrows and prop of @__arrows
		fn =-> 
			unless prop of @
				throw new Error "`#{fn.__input.__key}->#{prop}` undefined"
				
			@[prop]
			
		fn.__input = @

		
		unless @hasOwnProperty '__arrows'
			Object.defineProperty @, '__arrows', value:{} 
			
		@__arrows[prop] = fn
		
		return fn

		
Object.defineProperty Object.prototype, '__not', configurable:true, get:->
		fn =->
			unless typeof @__err is 'undefined'
				return @__err
			else
				return null
				
		fn.__input = @
		
		Object.defineProperty @, '__not', value:fn
		
		return fn

Object.defineProperty Object.prototype, '__store', value: (val)->
	Object.defineProperty @, '__value', value: val, configurable: true, writable: true
		
Object.defineProperty Object.prototype, '__clear', value: ->
	for key of @
		if @[key]?.__value
			@[key].__clear()
			
	@__input?.__clear() #__input is nonenumerable
	
	delete @__value
		
Object.defineProperty String.prototype, '__do', value: (cb)->
	value = @toString()
	process.nextTick -> cb value
	
Object.defineProperty Number.prototype, '__do', value: (cb)->
	value = @valueOf()
	process.nextTick -> cb value
	
Object.defineProperty Date.prototype, '__do', value: (cb)->
	value = @
	process.nextTick -> cb value
	
Object.defineProperty Object.prototype, '__do', value: (cb =->)->
		if @__value?
			return process.nextTick -> cb @__value
			
		unless typeof cb is 'function'
			throw new Error "__do callback must be a function."
			
		@__clear()
		
		code = __proto__: @
		count = 0
		error = null
		# console.log 'scanning'
		for key of code 
			
			while code[key]?.__value and code[key].__value isnt code[key]
				code[key] = code[key].__value
			
			unless code[key]?
				code[key] = null
				
			else if typeof code[key] in [ 'object', 'function' ]
					count++
					do (key)->
						cbs = [ (res)->
									# console.log key,'came back',res
									code[key] = res
								
									unless --count
										code.__store code
										return cb code
								]
						# console.log 'key', key,code[key].__do, 'been done'		
						code[key].__do.call code[key], (res)->(cb res for cb in cbs)	
						code[key].__store __do:(cb)->cbs.push cb
						
			else
				code[key] = code[key]
				
		unless count
			@__store code
			# console.log 'yielding thread'
			process.nextTick -> cb code

Object.defineProperty Object.prototype, '__exec', value: (input)->
		context = __proto__: @
		Object.defineProperty context, '__input', value: input
		context

Object.defineProperty Function.prototype, '__exec', value: (input)->
		fn = @
		context =(cb)->fn.call @, cb
		Object.defineProperty context, '__input', value: input
		context
		
Object.defineProperty Function.prototype, '__do', value: (cb)->
	# console.log 'function ben called', @
	unless typeof cb is 'function'
		throw new Error "__do callback must be a function."	
	if @__input?
		fn = @
		input = @__input
		
		while input?.__value and input.__value isnt input
			input = input.__value
		# context = Object.__ctx 

		res = input.__do (res)->
			try
				out = fn.call res, (err, doc)->
					if err
						doc = new Error err
						doc.__err = err
						
					return cb doc
			catch e
				e.__err ?= e.message
				out = e
				
			unless typeof out is 'undefined'
				return cb out
	else
		out = @call null, (err, doc)->
				if err
					doc = new Error err
					doc.__err = err
						
				return cb doc
				
		unless typeof out is 'undefined'
			process.nextTick -> cb out